<ui:composition
        xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:h="http://java.sun.com/jsf/html" xmlns="http://www.w3.org/1999/xhtml"
        xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:rich="http://richfaces.org/rich"
        xmlns:f="http://java.sun.com/jsf/core"  xmlns:g="http://www.ihe.net/gazelle">

    <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">
        <ui:param name="panel_id" value="AddNewTestStepsPanel"/>
        <ui:define name="panel_title">#{messages['net.ihe.gazelle.tm.AddANewTestStep']}</ui:define>
        <div class="row">
            <div class="col-md-4">
                <a4j:region id="stepTypeRegion" rendered="#{editTestStepsManager.isAutomatedStepEnabled()}">
                    <s:decorate id="stepTypeDecoration" template="/layout/form/_edit.xhtml">
                        <ui:param name="id" value="testStepTypeBox"/>
                        <ui:param name="required" value="#{editTestStepsManager.isCreating}"/>
                        <ui:define name="label">
                            <h:outputText value="#{messages['net.ihe.gazelle.tm.SelectTheTypeOfTestStep']}"
                                          rendered="#{editTestStepsManager.isCreating}">
                            </h:outputText>
                        </ui:define>
                        <h:selectOneMenu styleClass="form-control gzl-form-control"
                                         id="testStepTypeBox"
                                         disabled="#{!editTestStepsManager.isCreating}"
                                         value="#{editTestStepsManager.selectedStepType}"
                                         style="font-weight:bold;text-align:center;" required="true">
                            <s:selectItems value="#{editTestStepsManager.getPossibleTestStepType()}"
                                           var="selectedTestStepTypeKey"
                                           label="#{messages[selectedTestStepTypeKey]}"/>
                            <a4j:ajax event="change" render="testStepsManagement" execute="@this"
                                      listener="#{editTestStepsManager.updateSelectedTestStepType()}"/>
                        </h:selectOneMenu>
                    </s:decorate>
                </a4j:region>
            </div>
        </div>
        <div class="row">
            <div class="col-md-4">
                <a4j:region id="stepIndexRegion">
                    <s:decorate id="stepIndexDecoration" template="/layout/form/_edit.xhtml">
                        <ui:param name="id" value="stepIndex"/>
                        <ui:define name="label">#{messages['gazelle.tm.StepIndex']}</ui:define>
                        <h:inputText id="stepIndex" styleClass="form-control"
                                     value="#{editTestStepsManager.selectedTestSteps.stepIndex}"
                                     required="true">
                            <a4j:ajax event="blur" render="stepIndexDecoration"
                                      listener="#{editTestStepsManager.validateStepIndex()}"/>
                        </h:inputText>
                    </s:decorate>
                </a4j:region>
            </div>
            <div class="col-md-4">
                <a4j:region id="isSecuredRegion">
                    <s:decorate id="isSecuredDecoration"
                                template="/layout/form/_checkbox.xhtml">
                        <ui:define name="label">
                            <h:outputText id="isSecuredText"
                                          value="#{messages['gazelle.tm.testing.testsDefinition.secured']}"/>
                        </ui:define>
                        <h:selectBooleanCheckbox id="isSecured"
                                                 value="#{editTestStepsManager.selectedTestSteps.secured}"/>
                    </s:decorate>
                </a4j:region>
            </div>
            <div class="col-md-4">
                <a4j:region id="autoResponseRegion">
                    <s:decorate id="autoResponseDecoration" template="/layout/form/_checkbox.xhtml">
                        <ui:define name="label">#{messages['gazelle.tm.AutoResponse']}</ui:define>
                        <h:selectBooleanCheckbox id="autoResponse"
                                                 value="#{editTestStepsManager.autoResponse}">
                            <a4j:ajax event="change"
                                      render="testRolesInitiatorDecoration,transactionTestRolesResponderIfNotAutoResponse,messageTypeDecoration"
                                      listener="#{editTestStepsManager.resetTransactionValue()}"/>
                        </h:selectBooleanCheckbox>
                    </s:decorate>
                </a4j:region>
            </div>
        </div>
        <a4j:region id="testRolesInitiatorRegion">
            <s:decorate id="testRolesInitiatorDecoration" template="/layout/form/_edit.xhtml">
                <ui:define name="label">#{messages['gazelle.tm.InitiatorRole']}</ui:define>
                <ui:param name="id" value="creationInitiatorListBox"/>
                <h:selectOneMenu styleClass="form-control gzl-form-control"
                                 id="creationInitiatorListBox"
                                 value="#{editTestStepsManager.selectedTestSteps.testRolesInitiator}"
                                 style="font-weight:bold;text-align:center;" required="true">
                    <s:selectItems value="#{editTestStepsManager.getPossibleInitiatorTestRoles()}"
                                   var="selectedInitiatorTestRoles"
                                   noSelectionLabel="#{messages['gazelle.common.PleaseSelect']}"
                                   label="#{selectedInitiatorTestRoles.roleInTest.keyword}"/>
                    <a4j:ajax event="change" render="transactionDecoration,udagediv" execute="@this"
                              listener="#{editTestStepsManager.resetTransactionValue()}"/>
                </h:selectOneMenu>
                <rich:message for="creationInitiatorListBox" style="color:red;font-size:x-small;">
                    <f:facet name="errorMarker">
                        <span class="gzl-icon-times-circle"/>
                    </f:facet>
                </rich:message>
            </s:decorate>
        </a4j:region>
        <s:div id="transactionTestRolesResponderIfNotAutoResponse">
            <h:panelGrid columns="2">
                <a4j:region id="transactionRegion" rendered="#{!editTestStepsManager.autoResponse}">
                    <s:decorate id="transactionDecoration" template="/layout/form/_edit.xhtml">
                        <ui:define name="label">#{messages['gazelle.tf.Transaction']}</ui:define>
                        <ui:param name="id" value="CreateTransactionListBox"/>
                        <h:selectOneMenu styleClass="form-control gzl-form-control"
                                         id="CreateTransactionListBox" required="true"
                                         value="#{editTestStepsManager.selectedTestSteps.transaction}"
                                         style="font-weight:bold;text-align:center;"
                                         disabled="#{editTestStepsManager.autoResponse}">
                            <s:selectItems value="#{editTestStepsManager.possibleTransactions}"
                                           var="selectedTransaction" noSelectionLabel="..."
                                           label="#{selectedTransaction.keyword}"/>
                            <a4j:ajax event="change"
                                      render="testRolesResponderDecoration,udagediv,messageTypeDecoration"
                                      execute="@this"
                                      listener="#{editTestStepsManager.resetTestRolesResponderValue()}"/>
                        </h:selectOneMenu>
                        <rich:message for="CreateTransactionListBox"
                                      style="color:red;font-size:x-small;">
                            <f:facet name="errorMarker">
                                <span class="gzl-icon-times-circle"/>
                            </f:facet>
                        </rich:message>
                    </s:decorate>
                </a4j:region>
                <s:div id="udagediv">
                    <s:decorate id="usagedec" template="/layout/form/_edit.xhtml"
                                rendered="#{editTestStepsManager.canEditUsage()}">
                        <ui:define name="label">#{messages['gazelle.tf.Usage']}</ui:define>
                        <ui:param name="id" value="usagesel"/>
                        <h:selectOneMenu styleClass="form-control gzl-form-control" id="usagesel"
                                         value="#{editTestStepsManager.selectedTestSteps.wstransactionUsage}"
                                         disabled="#{editTestStepsManager.autoResponse}">
                            <s:selectItems value="#{editTestStepsManager.possibleWSTransactionUsages}"
                                           var="wstr" noSelectionLabel="..." label="#{wstr.usage}"/>
                        </h:selectOneMenu>
                    </s:decorate>
                </s:div>
            </h:panelGrid>
            <a4j:region id="testRolesResponderRegion" rendered="#{!editTestStepsManager.autoResponse}">
                <s:decorate id="testRolesResponderDecoration" template="/layout/form/_edit.xhtml">
                    <ui:define name="label">#{messages['gazelle.tm.ResponderRole']}</ui:define>
                    <ui:param name="id" value="creationResponderListBox"/>
                    <h:selectOneMenu styleClass="form-control gzl-form-control"
                                     id="creationResponderListBox" required="true"
                                     value="#{editTestStepsManager.selectedTestSteps.testRolesResponder}"
                                     style="font-weight:bold;text-align:center;"
                                     disabled="#{editTestStepsManager.autoResponse}">
                        <s:selectItems value="#{editTestStepsManager.possibleTestRolesResponder}"
                                       var="selectedResponderTestRoles"
                                       noSelectionLabel="#{messages['gazelle.common.PleaseSelect']}"
                                       label="#{selectedResponderTestRoles.roleInTest.keyword}"/>
                    </h:selectOneMenu>
                </s:decorate>
            </a4j:region>
        </s:div>
        <a4j:region id="messageTypeRegion">
            <s:decorate id="messageTypeDecoration" template="/layout/form/_edit.xhtml">
                <ui:define name="label">#{messages['gazelle.tf.table.mptrans']}</ui:define>
                <ui:param name="id" value="messageTypeIfAutoResponse"/>
                <h:selectOneMenu styleClass="form-control gzl-form-control"
                                 id="creationMessageTypeListBox"
                                 required="true"
                                 value="#{editTestStepsManager.selectedTestSteps.messageType}"
                                 style="font-weight:bold;text-align:center;"
                                 disabled="#{editTestStepsManager.autoResponse}"
                                 rendered="#{!editTestStepsManager.autoResponse and editTestStepsManager.getPossibleMessageType()!=null}">
                    <s:selectItems value="#{editTestStepsManager.getPossibleMessageType()}"
                                   var="messageType"
                                   noSelectionLabel="#{messages['gazelle.common.PleaseSelect']}"
                                   label="#{messageType}"/>
                </h:selectOneMenu>
                <h:inputText id="messageTypeIfAutoResponse" styleClass="form-control"
                             rendered="#{editTestStepsManager.autoResponse or editTestStepsManager.getPossibleMessageType()==null}"
                             value="#{editTestStepsManager.selectedTestSteps.messageType}"
                             required="true">
                </h:inputText>
            </s:decorate>
        </a4j:region>
        <a4j:region id="optionRegion">
            <s:decorate id="optionDecoration" template="/layout/form/_edit.xhtml">
                <ui:define name="label">#{messages['gazelle.tf.LabelOption']}</ui:define>
                <ui:param name="id" value="testStepsOptionListBox"/>
                <h:selectOneMenu styleClass="form-control gzl-form-control" id="testStepsOptionListBox"
                                 value="#{editTestStepsManager.selectedTestSteps.testStepsOption}"
                                 style="font-weight:bold;text-align:center;">
                    <s:selectItems value="#{editTestStepsManager.possibleTestStepsOptions}"
                                   var="selectedTestStepsOption" hideNoSelectionLabel="true"
                                   label="#{selectedTestStepsOption.labelToDisplay}"/>
                </h:selectOneMenu>
            </s:decorate>
        </a4j:region>
        <a4j:region id="testStepsDescriptionRegion">
            <s:decorate id="testStepsDescriptionDecoration" template="/layout/form/_edit.xhtml">
                <ui:param name="id" value="descarea"/>
                <ui:define name="label">#{messages['gazelle.tf.table.Description']}</ui:define>
                <h:inputTextarea styleClass=" form-control" rows="10" cols="100" id="descarea"
                                 value="#{editTestStepsManager.selectedTestSteps.description}"
                                 required="true">
                    <a4j:ajax event="blur" render="testStepsDescriptionDecoration"
                              listener="#{editTestStepsManager.validateTestStepsDescription()}"/>
                </h:inputTextarea>
            </s:decorate>
        </a4j:region>
        <br/>
        <s:div id="uploadScript" rendered="#{editTestStepsManager.isAutomatedTestStep()}">
            <s:div rendered="#{editTestStepsManager.getScript() == null}">
                <a4j:region id="uploadScriptRegion">
                    <s:decorate id="uploadScriptDecoration" template="/layout/form/_edit.xhtml">
                        <ui:param name="id" value="scriptFileUpload"/>
                        <ui:define name="label">
                            #{messages['net.ihe.gazelle.tm.ThisTestStepWorksWithAnAutomationScriptPleaseUpl']} *
                        </ui:define>
                        <rich:fileUpload
                                fileUploadListener="#{editTestStepsManager.uploadListener}"
                                maxFilesQuantity="1"
                                listHeight="60px"
                                immediateUpload="true">
                            <a4j:ajax event="uploadcomplete" render="uploadScript, footer"/>
                        </rich:fileUpload>
                    </s:decorate>
                </a4j:region>
            </s:div>
            <s:div rendered="#{editTestStepsManager.getUploadErrorMessage() != null}">
                <h:outputText value="#{messages['net.ihe.gazelle.tm.TheScriptHasBeenValidatedByAJsonSchemaAndParsed']}"/>
                <br/>
                <div style="white-space: pre-wrap">
                    <h:outputText value="#{editTestStepsManager.getUploadErrorMessage()}" style="color:crimson;"/>
                </div>
            </s:div>
            <s:div id="scriptNameInfo"
                   rendered="#{editTestStepsManager.getScript() != null}"
                   styleClass="form-horizontal">
                <h:outputText style="font-weight:bold"
                              value="#{messages['net.ihe.gazelle.tm.AutomatedTestStepScript']}"/>
                <div class="row">
                    <div class="col-md-2">
                        <h:commandLink id="downloadScript"
                                       value="#{editTestStepsManager.getScriptName()}"
                                       action="#{editTestStepsManager.downloadScript()}"
                                       immediate="true"/>
                        <a4j:commandLink id="deleteUploadedScript"
                                         actionListener="#{editTestStepsManager.resetUpload()}"
                                         execute="@this"
                                         title="#{messages['gazelle.common.button.Delete']}"
                                         render="uploadScript">
                            <span class="gzl-icon-trash-o"/>
                        </a4j:commandLink>
                    </div>
                </div>
            </s:div>
        </s:div>
        <br/>
        <s:div id="ListCIInput">
            <h:panelGrid columns="5" id="columnGrToCIIn">
                <h:outputText value="#{messages['gazelle.tm.ContextualInformationInput']}"
                              style="font-weight:bold;"/>

                <a4j:commandLink event="click"
                                 title="#{messages['gazelle.tm.AddContextualInformation']}"
                                 oncomplete="jq162('#AddContextualInformation').modal('show');"
                                 execute="@this" render="AddContextualInformation, :CIForm"
                                 actionListener="#{editTestStepsManager.initializeContextualInformation(1)}">
                    <span class="gzl-icon-plus"/>
                </a4j:commandLink>

                <a4j:commandLink event="click"
                                 title="#{messages['gazelle.tm.LinkToContextualInformation']}"
                                 oncomplete="jq162('#LinkContextualInformation').modal('show');"
                                 execute="@this" render="LinkContextualInformation, :CILinkForm"
                                 actionListener="#{editTestStepsManager.initializeContextualInformation(1)}">
                    <span class="gzl-icon-arrow-circle-down"/>
                </a4j:commandLink>

            </h:panelGrid>
            <br/>
            <rich:dataTable id="dataTabOfCI" var="currentCI"
                            value="#{editTestStepsManager.selectedTestSteps.inputContextualInformationList}"
                            rowKeyVar="rowNumber"
                            rendered="#{editTestStepsManager.viewTableOfCIInput()}"


                            rows="10" render="ds">
                <g:column sortBy="#{'id'}" sortOrder="ascending">
                    <ui:define name="header">#{messages['gazelle.tf.table.Id']}</ui:define>
                    <h:outputText value="#{currentCI.id}"/>
                </g:column>
                <g:column sortBy="#{'label'}" sortOrder="ascending">
                    <ui:define name="header">#{messages['gazelle.tf.table.Label']}</ui:define>
                    <h:outputText value="#{currentCI.label}"/>
                </g:column>
                <g:column sortBy="#{'path'}" sortOrder="ascending">
                    <ui:define name="header">
                        #{messages['gazelle.financial.invoice.InvoicePathForArray']}
                    </ui:define>
                    <h:outputText value="#{currentCI.path.keyword}"/>
                </g:column>
                <g:column sortBy="#{'value'}" sortOrder="ascending">
                    <ui:define name="header">#{messages['gazelle.tm.testing.instance.ValueURL']}
                    </ui:define>
                    <h:outputText value="#{currentCI.value}"/>
                </g:column>
                <g:column>
                    <ui:define name="header">#{messages['gazelle.common.Action']}</ui:define>
                    <div class="gzl-never-wrap">

                        <a4j:commandLink event="click"
                                         rendered="#{editTestStepsManager.canEditCIAsInput(currentCI)}"
                                         oncomplete="jq162('#AddContextualInformation').modal('show');"
                                         render="AddContextualInformation, :CIForm"
                                         actionListener="#{editTestStepsManager.updateSelectedContextualInformation(currentCI,1)}">
                            <span class="gzl-icon-pencil"/>
                        </a4j:commandLink>


                        <a4j:commandLink event="click"
                                         rendered="#{applicationPreferenceManager.isPossibleToDeleteOnGMM()}"
                                         oncomplete="jq162('#DeleteCIModal').modal('show');"
                                         render=" :deleteCIForm, DeleteCIModal"
                                         actionListener="#{editTestStepsManager.updateSelectedContextualInformationForInput(currentCI)}">
                            <span class="gzl-icon-trash-o"/>
                        </a4j:commandLink>


                    </div>

                </g:column>
                <f:facet name="footer">
                    <rich:dataScroller id="ds" maxPages="10" renderIfSinglePage="false"/>
                </f:facet>
            </rich:dataTable>
        </s:div>
        <br/>
        <s:div id="ListCIOutput">
            <h:panelGrid columns="3" id="columnGrToCIOut">
                <h:outputText value="#{messages['gazelle.tm.ContextualInformationOutput']}"
                              style="font-weight:bold;"/>

                <a4j:commandLink event="click"
                                 title="#{messages['gazelle.tm.AddContextualInformation']}"
                                 oncomplete="jq162('#AddContextualInformation').modal('show');"
                                 execute="@this" render="AddContextualInformation, :CIForm"
                                 actionListener="#{editTestStepsManager.initializeContextualInformation(2)}">
                    <span class="gzl-icon-plus"/>
                </a4j:commandLink>

            </h:panelGrid>
            <br/>
            <br/>
            <rich:dataTable id="dataTabOfCIOut" var="currentCI"
                            value="#{editTestStepsManager.selectedTestSteps.outputContextualInformationList}"
                            rowKeyVar="rowNumber"
                            rendered="#{editTestStepsManager.viewTableOfCIOutput()}"


                            rows="10" render="dsOut">
                <g:column sortBy="#{'id'}" sortOrder="ascending">
                    <ui:define name="header">#{messages['gazelle.tf.table.Id']}</ui:define>
                    <h:outputText value="#{currentCI.id}"/>
                </g:column>
                <g:column sortBy="#{'label'}" sortOrder="ascending">
                    <ui:define name="header">#{messages['gazelle.tf.table.Label']}</ui:define>
                    <h:outputText value="#{currentCI.label}"/>
                </g:column>
                <g:column sortBy="#{'path'}" sortOrder="ascending">
                    <ui:define name="header">
                        #{messages['gazelle.financial.invoice.InvoicePathForArray']}
                    </ui:define>
                    <h:outputText value="#{currentCI.path.keyword}"/>
                </g:column>
                <g:column sortBy="#{'value'}" sortOrder="ascending">
                    <ui:define name="header">#{messages['gazelle.tm.testing.instance.ValueURL']}
                    </ui:define>
                    <h:outputText value="#{currentCI.value}"/>
                </g:column>
                <g:column>
                    <ui:define name="header">#{messages['gazelle.common.Action']}</ui:define>
                    <div class="gzl-never-wrap">

                        <a4j:commandLink event="click"
                                         oncomplete="jq162('#AddContextualInformation').modal('show');"
                                         render="AddContextualInformation, :CIForm"
                                         actionListener="#{editTestStepsManager.updateSelectedContextualInformation(currentCI,2)}">
                            <span class="gzl-icon-pencil"/>
                        </a4j:commandLink>


                        <a4j:commandLink event="click"
                                         rendered="#{applicationPreferenceManager.isPossibleToDeleteOnGMM()}"
                                         oncomplete="jq162('#DeleteCIModal').modal('show');"
                                         render=" :deleteCIForm, DeleteCIModal"
                                         actionListener="#{editTestStepsManager.updateSelectedContextualInformationForOutput(currentCI)}">
                            <span class="gzl-icon-trash-o"/>
                        </a4j:commandLink>
                    </div>
                </g:column>
                <f:facet name="footer">
                    <rich:dataScroller id="dsOut" maxPages="10" renderIfSinglePage="false"/>
                </f:facet>
            </rich:dataTable>
        </s:div>
        <ui:define name="panel_footer">
            <a4j:commandButton styleClass="gzl-btn" id="cancedit"
                               value="#{messages['gazelle.common.button.Cancel']}"
                               actionListener="#{editTestStepsManager.cancelTestStepsCreation()}"
                               rendered="#{s:hasPermission('TestsDefinitionsAdministrationManager', 'EditTest', null)}"
                               render="testStepsManagement" execute="@this"/>
            <a4j:commandButton value="#{messages['gazelle.tm.AddThisStep']}" id="addthissteps"
                               actionListener="#{editTestStepsManager.createTestStep()}"
                               styleClass="gzl-btn-green"
                               rendered="#{editTestStepsManager.selectedTestSteps.id == null and s:hasPermission('TestsDefinitionsAdministrationManager', 'EditTest', null)}"
                               render="testStepsManagement"/>
            <a4j:commandButton value="#{messages['gazelle.tm.UpdateThisStep']}" id="updatethissteps"
                               actionListener="#{editTestStepsManager.updateTestStep()}"
                               styleClass="btn btn-warning"
                               rendered="#{editTestStepsManager.selectedTestSteps.id != null and s:hasPermission('TestsDefinitionsAdministrationManager', 'EditTest', null)}"
                               render="testStepsManagement"/>
        </ui:define>
    </ui:decorate>
</ui:composition>